(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"), require("date-fns"));
	else if(typeof define === 'function' && define.amd)
		define(["react", "date-fns"], factory);
	else if(typeof exports === 'object')
		exports["DayPicker"] = factory(require("react"), require("date-fns"));
	else
		root["DayPicker"] = factory(root["React"], root["DateFns"]);
})(self, function(__WEBPACK_EXTERNAL_MODULE__698__, __WEBPACK_EXTERNAL_MODULE__259__) {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 348:
/***/ ((module, exports) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = buildFormatLongFn;

function buildFormatLongFn(args) {
  return function (dirtyOptions) {
    var options = dirtyOptions || {};
    var width = options.width ? String(options.width) : args.defaultWidth;
    var format = args.formats[width] || args.formats[args.defaultWidth];
    return format;
  };
}

module.exports = exports.default;

/***/ }),

/***/ 738:
/***/ ((module, exports) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = buildLocalizeFn;

function buildLocalizeFn(args) {
  return function (dirtyIndex, dirtyOptions) {
    var options = dirtyOptions || {};
    var context = options.context ? String(options.context) : 'standalone';
    var valuesArray;

    if (context === 'formatting' && args.formattingValues) {
      var defaultWidth = args.defaultFormattingWidth || args.defaultWidth;
      var width = options.width ? String(options.width) : defaultWidth;
      valuesArray = args.formattingValues[width] || args.formattingValues[defaultWidth];
    } else {
      var _defaultWidth = args.defaultWidth;

      var _width = options.width ? String(options.width) : args.defaultWidth;

      valuesArray = args.values[_width] || args.values[_defaultWidth];
    }

    var index = args.argumentCallback ? args.argumentCallback(dirtyIndex) : dirtyIndex;
    return valuesArray[index];
  };
}

module.exports = exports.default;

/***/ }),

/***/ 653:
/***/ ((module, exports) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = buildMatchFn;

function buildMatchFn(args) {
  return function (dirtyString, dirtyOptions) {
    var string = String(dirtyString);
    var options = dirtyOptions || {};
    var width = options.width;
    var matchPattern = width && args.matchPatterns[width] || args.matchPatterns[args.defaultMatchWidth];
    var matchResult = string.match(matchPattern);

    if (!matchResult) {
      return null;
    }

    var matchedString = matchResult[0];
    var parsePatterns = width && args.parsePatterns[width] || args.parsePatterns[args.defaultParseWidth];
    var value;

    if (Object.prototype.toString.call(parsePatterns) === '[object Array]') {
      value = findIndex(parsePatterns, function (pattern) {
        return pattern.test(matchedString);
      });
    } else {
      value = findKey(parsePatterns, function (pattern) {
        return pattern.test(matchedString);
      });
    }

    value = args.valueCallback ? args.valueCallback(value) : value;
    value = options.valueCallback ? options.valueCallback(value) : value;
    return {
      value: value,
      rest: string.slice(matchedString.length)
    };
  };
}

function findKey(object, predicate) {
  for (var key in object) {
    if (object.hasOwnProperty(key) && predicate(object[key])) {
      return key;
    }
  }
}

function findIndex(array, predicate) {
  for (var key = 0; key < array.length; key++) {
    if (predicate(array[key])) {
      return key;
    }
  }
}

module.exports = exports.default;

/***/ }),

/***/ 604:
/***/ ((module, exports) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = buildMatchPatternFn;

function buildMatchPatternFn(args) {
  return function (dirtyString, dirtyOptions) {
    var string = String(dirtyString);
    var options = dirtyOptions || {};
    var matchResult = string.match(args.matchPattern);

    if (!matchResult) {
      return null;
    }

    var matchedString = matchResult[0];
    var parseResult = string.match(args.parsePattern);

    if (!parseResult) {
      return null;
    }

    var value = args.valueCallback ? args.valueCallback(parseResult[0]) : parseResult[0];
    value = options.valueCallback ? options.valueCallback(value) : value;
    return {
      value: value,
      rest: string.slice(matchedString.length)
    };
  };
}

module.exports = exports.default;

/***/ }),

/***/ 361:
/***/ ((module, exports) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = formatDistance;
var formatDistanceLocale = {
  lessThanXSeconds: {
    one: 'less than a second',
    other: 'less than {{count}} seconds'
  },
  xSeconds: {
    one: '1 second',
    other: '{{count}} seconds'
  },
  halfAMinute: 'half a minute',
  lessThanXMinutes: {
    one: 'less than a minute',
    other: 'less than {{count}} minutes'
  },
  xMinutes: {
    one: '1 minute',
    other: '{{count}} minutes'
  },
  aboutXHours: {
    one: 'about 1 hour',
    other: 'about {{count}} hours'
  },
  xHours: {
    one: '1 hour',
    other: '{{count}} hours'
  },
  xDays: {
    one: '1 day',
    other: '{{count}} days'
  },
  aboutXWeeks: {
    one: 'about 1 week',
    other: 'about {{count}} weeks'
  },
  xWeeks: {
    one: '1 week',
    other: '{{count}} weeks'
  },
  aboutXMonths: {
    one: 'about 1 month',
    other: 'about {{count}} months'
  },
  xMonths: {
    one: '1 month',
    other: '{{count}} months'
  },
  aboutXYears: {
    one: 'about 1 year',
    other: 'about {{count}} years'
  },
  xYears: {
    one: '1 year',
    other: '{{count}} years'
  },
  overXYears: {
    one: 'over 1 year',
    other: 'over {{count}} years'
  },
  almostXYears: {
    one: 'almost 1 year',
    other: 'almost {{count}} years'
  }
};

function formatDistance(token, count, options) {
  options = options || {};
  var result;

  if (typeof formatDistanceLocale[token] === 'string') {
    result = formatDistanceLocale[token];
  } else if (count === 1) {
    result = formatDistanceLocale[token].one;
  } else {
    result = formatDistanceLocale[token].other.replace('{{count}}', count);
  }

  if (options.addSuffix) {
    if (options.comparison > 0) {
      return 'in ' + result;
    } else {
      return result + ' ago';
    }
  }

  return result;
}

module.exports = exports.default;

/***/ }),

/***/ 780:
/***/ ((module, exports, __webpack_require__) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = void 0;

var _index = _interopRequireDefault(__webpack_require__(348));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var dateFormats = {
  full: 'EEEE, MMMM do, y',
  long: 'MMMM do, y',
  medium: 'MMM d, y',
  short: 'MM/dd/yyyy'
};
var timeFormats = {
  full: 'h:mm:ss a zzzz',
  long: 'h:mm:ss a z',
  medium: 'h:mm:ss a',
  short: 'h:mm a'
};
var dateTimeFormats = {
  full: "{{date}} 'at' {{time}}",
  long: "{{date}} 'at' {{time}}",
  medium: '{{date}}, {{time}}',
  short: '{{date}}, {{time}}'
};
var formatLong = {
  date: (0, _index.default)({
    formats: dateFormats,
    defaultWidth: 'full'
  }),
  time: (0, _index.default)({
    formats: timeFormats,
    defaultWidth: 'full'
  }),
  dateTime: (0, _index.default)({
    formats: dateTimeFormats,
    defaultWidth: 'full'
  })
};
var _default = formatLong;
exports.default = _default;
module.exports = exports.default;

/***/ }),

/***/ 663:
/***/ ((module, exports) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = formatRelative;
var formatRelativeLocale = {
  lastWeek: "'last' eeee 'at' p",
  yesterday: "'yesterday at' p",
  today: "'today at' p",
  tomorrow: "'tomorrow at' p",
  nextWeek: "eeee 'at' p",
  other: 'P'
};

function formatRelative(token, _date, _baseDate, _options) {
  return formatRelativeLocale[token];
}

module.exports = exports.default;

/***/ }),

/***/ 350:
/***/ ((module, exports, __webpack_require__) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = void 0;

var _index = _interopRequireDefault(__webpack_require__(738));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var eraValues = {
  narrow: ['B', 'A'],
  abbreviated: ['BC', 'AD'],
  wide: ['Before Christ', 'Anno Domini']
};
var quarterValues = {
  narrow: ['1', '2', '3', '4'],
  abbreviated: ['Q1', 'Q2', 'Q3', 'Q4'],
  wide: ['1st quarter', '2nd quarter', '3rd quarter', '4th quarter'] // Note: in English, the names of days of the week and months are capitalized.
  // If you are making a new locale based on this one, check if the same is true for the language you're working on.
  // Generally, formatted dates should look like they are in the middle of a sentence,
  // e.g. in Spanish language the weekdays and months should be in the lowercase.

};
var monthValues = {
  narrow: ['J', 'F', 'M', 'A', 'M', 'J', 'J', 'A', 'S', 'O', 'N', 'D'],
  abbreviated: ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
  wide: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']
};
var dayValues = {
  narrow: ['S', 'M', 'T', 'W', 'T', 'F', 'S'],
  short: ['Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa'],
  abbreviated: ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'],
  wide: ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday']
};
var dayPeriodValues = {
  narrow: {
    am: 'a',
    pm: 'p',
    midnight: 'mi',
    noon: 'n',
    morning: 'morning',
    afternoon: 'afternoon',
    evening: 'evening',
    night: 'night'
  },
  abbreviated: {
    am: 'AM',
    pm: 'PM',
    midnight: 'midnight',
    noon: 'noon',
    morning: 'morning',
    afternoon: 'afternoon',
    evening: 'evening',
    night: 'night'
  },
  wide: {
    am: 'a.m.',
    pm: 'p.m.',
    midnight: 'midnight',
    noon: 'noon',
    morning: 'morning',
    afternoon: 'afternoon',
    evening: 'evening',
    night: 'night'
  }
};
var formattingDayPeriodValues = {
  narrow: {
    am: 'a',
    pm: 'p',
    midnight: 'mi',
    noon: 'n',
    morning: 'in the morning',
    afternoon: 'in the afternoon',
    evening: 'in the evening',
    night: 'at night'
  },
  abbreviated: {
    am: 'AM',
    pm: 'PM',
    midnight: 'midnight',
    noon: 'noon',
    morning: 'in the morning',
    afternoon: 'in the afternoon',
    evening: 'in the evening',
    night: 'at night'
  },
  wide: {
    am: 'a.m.',
    pm: 'p.m.',
    midnight: 'midnight',
    noon: 'noon',
    morning: 'in the morning',
    afternoon: 'in the afternoon',
    evening: 'in the evening',
    night: 'at night'
  }
};

function ordinalNumber(dirtyNumber, _dirtyOptions) {
  var number = Number(dirtyNumber); // If ordinal numbers depend on context, for example,
  // if they are different for different grammatical genders,
  // use `options.unit`:
  //
  //   var options = dirtyOptions || {}
  //   var unit = String(options.unit)
  //
  // where `unit` can be 'year', 'quarter', 'month', 'week', 'date', 'dayOfYear',
  // 'day', 'hour', 'minute', 'second'

  var rem100 = number % 100;

  if (rem100 > 20 || rem100 < 10) {
    switch (rem100 % 10) {
      case 1:
        return number + 'st';

      case 2:
        return number + 'nd';

      case 3:
        return number + 'rd';
    }
  }

  return number + 'th';
}

var localize = {
  ordinalNumber: ordinalNumber,
  era: (0, _index.default)({
    values: eraValues,
    defaultWidth: 'wide'
  }),
  quarter: (0, _index.default)({
    values: quarterValues,
    defaultWidth: 'wide',
    argumentCallback: function (quarter) {
      return Number(quarter) - 1;
    }
  }),
  month: (0, _index.default)({
    values: monthValues,
    defaultWidth: 'wide'
  }),
  day: (0, _index.default)({
    values: dayValues,
    defaultWidth: 'wide'
  }),
  dayPeriod: (0, _index.default)({
    values: dayPeriodValues,
    defaultWidth: 'wide',
    formattingValues: formattingDayPeriodValues,
    defaultFormattingWidth: 'wide'
  })
};
var _default = localize;
exports.default = _default;
module.exports = exports.default;

/***/ }),

/***/ 49:
/***/ ((module, exports, __webpack_require__) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = void 0;

var _index = _interopRequireDefault(__webpack_require__(604));

var _index2 = _interopRequireDefault(__webpack_require__(653));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var matchOrdinalNumberPattern = /^(\d+)(th|st|nd|rd)?/i;
var parseOrdinalNumberPattern = /\d+/i;
var matchEraPatterns = {
  narrow: /^(b|a)/i,
  abbreviated: /^(b\.?\s?c\.?|b\.?\s?c\.?\s?e\.?|a\.?\s?d\.?|c\.?\s?e\.?)/i,
  wide: /^(before christ|before common era|anno domini|common era)/i
};
var parseEraPatterns = {
  any: [/^b/i, /^(a|c)/i]
};
var matchQuarterPatterns = {
  narrow: /^[1234]/i,
  abbreviated: /^q[1234]/i,
  wide: /^[1234](th|st|nd|rd)? quarter/i
};
var parseQuarterPatterns = {
  any: [/1/i, /2/i, /3/i, /4/i]
};
var matchMonthPatterns = {
  narrow: /^[jfmasond]/i,
  abbreviated: /^(jan|feb|mar|apr|may|jun|jul|aug|sep|oct|nov|dec)/i,
  wide: /^(january|february|march|april|may|june|july|august|september|october|november|december)/i
};
var parseMonthPatterns = {
  narrow: [/^j/i, /^f/i, /^m/i, /^a/i, /^m/i, /^j/i, /^j/i, /^a/i, /^s/i, /^o/i, /^n/i, /^d/i],
  any: [/^ja/i, /^f/i, /^mar/i, /^ap/i, /^may/i, /^jun/i, /^jul/i, /^au/i, /^s/i, /^o/i, /^n/i, /^d/i]
};
var matchDayPatterns = {
  narrow: /^[smtwf]/i,
  short: /^(su|mo|tu|we|th|fr|sa)/i,
  abbreviated: /^(sun|mon|tue|wed|thu|fri|sat)/i,
  wide: /^(sunday|monday|tuesday|wednesday|thursday|friday|saturday)/i
};
var parseDayPatterns = {
  narrow: [/^s/i, /^m/i, /^t/i, /^w/i, /^t/i, /^f/i, /^s/i],
  any: [/^su/i, /^m/i, /^tu/i, /^w/i, /^th/i, /^f/i, /^sa/i]
};
var matchDayPeriodPatterns = {
  narrow: /^(a|p|mi|n|(in the|at) (morning|afternoon|evening|night))/i,
  any: /^([ap]\.?\s?m\.?|midnight|noon|(in the|at) (morning|afternoon|evening|night))/i
};
var parseDayPeriodPatterns = {
  any: {
    am: /^a/i,
    pm: /^p/i,
    midnight: /^mi/i,
    noon: /^no/i,
    morning: /morning/i,
    afternoon: /afternoon/i,
    evening: /evening/i,
    night: /night/i
  }
};
var match = {
  ordinalNumber: (0, _index.default)({
    matchPattern: matchOrdinalNumberPattern,
    parsePattern: parseOrdinalNumberPattern,
    valueCallback: function (value) {
      return parseInt(value, 10);
    }
  }),
  era: (0, _index2.default)({
    matchPatterns: matchEraPatterns,
    defaultMatchWidth: 'wide',
    parsePatterns: parseEraPatterns,
    defaultParseWidth: 'any'
  }),
  quarter: (0, _index2.default)({
    matchPatterns: matchQuarterPatterns,
    defaultMatchWidth: 'wide',
    parsePatterns: parseQuarterPatterns,
    defaultParseWidth: 'any',
    valueCallback: function (index) {
      return index + 1;
    }
  }),
  month: (0, _index2.default)({
    matchPatterns: matchMonthPatterns,
    defaultMatchWidth: 'wide',
    parsePatterns: parseMonthPatterns,
    defaultParseWidth: 'any'
  }),
  day: (0, _index2.default)({
    matchPatterns: matchDayPatterns,
    defaultMatchWidth: 'wide',
    parsePatterns: parseDayPatterns,
    defaultParseWidth: 'any'
  }),
  dayPeriod: (0, _index2.default)({
    matchPatterns: matchDayPeriodPatterns,
    defaultMatchWidth: 'any',
    parsePatterns: parseDayPeriodPatterns,
    defaultParseWidth: 'any'
  })
};
var _default = match;
exports.default = _default;
module.exports = exports.default;

/***/ }),

/***/ 626:
/***/ ((module, exports, __webpack_require__) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = void 0;

var _index = _interopRequireDefault(__webpack_require__(361));

var _index2 = _interopRequireDefault(__webpack_require__(780));

var _index3 = _interopRequireDefault(__webpack_require__(663));

var _index4 = _interopRequireDefault(__webpack_require__(350));

var _index5 = _interopRequireDefault(__webpack_require__(49));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @type {Locale}
 * @category Locales
 * @summary English locale (United States).
 * @language English
 * @iso-639-2 eng
 * @author Sasha Koss [@kossnocorp]{@link https://github.com/kossnocorp}
 * @author Lesha Koss [@leshakoss]{@link https://github.com/leshakoss}
 */
var locale = {
  code: 'en-US',
  formatDistance: _index.default,
  formatLong: _index2.default,
  formatRelative: _index3.default,
  localize: _index4.default,
  match: _index5.default,
  options: {
    weekStartsOn: 0
    /* Sunday */
    ,
    firstWeekContainsDate: 1
  }
};
var _default = locale;
exports.default = _default;
module.exports = exports.default;

/***/ }),

/***/ 259:
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE__259__;

/***/ }),

/***/ 698:
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE__698__;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		if(__webpack_module_cache__[moduleId]) {
/******/ 			return __webpack_module_cache__[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "Caption": () => (/* reexport */ Caption),
  "Day": () => (/* reexport */ Day),
  "DayPicker": () => (/* reexport */ DayPicker),
  "DayPickerContext": () => (/* reexport */ DayPickerContext),
  "DayPickerProvider": () => (/* reexport */ DayPickerProvider),
  "Dropdown": () => (/* reexport */ Dropdown),
  "Head": () => (/* reexport */ Head),
  "IconDropdown": () => (/* reexport */ IconDropdown),
  "IconNext": () => (/* reexport */ IconNext),
  "IconPrev": () => (/* reexport */ IconPrev),
  "KeyCode": () => (/* reexport */ KeyCode),
  "MonthsDropdown": () => (/* reexport */ MonthsDropdown),
  "NavigationContext": () => (/* reexport */ NavigationContext),
  "NavigationProvider": () => (/* reexport */ NavigationProvider),
  "Root": () => (/* reexport */ Root),
  "Row": () => (/* reexport */ Row),
  "SelectionContext": () => (/* reexport */ SelectionContext),
  "SelectionProvider": () => (/* reexport */ SelectionProvider),
  "Table": () => (/* reexport */ Table),
  "UIElement": () => (/* reexport */ UIElement),
  "WeekNumber": () => (/* reexport */ WeekNumber),
  "YearsDropdown": () => (/* reexport */ YearsDropdown),
  "useDayPicker": () => (/* reexport */ useDayPicker),
  "useInput": () => (/* reexport */ useInput),
  "useModifiers": () => (/* reexport */ useModifiers),
  "useNavigation": () => (/* reexport */ useNavigation),
  "useSelection": () => (/* reexport */ useSelection)
});

// NAMESPACE OBJECT: ./src/hooks/useDayPicker/formatters/index.ts
var formatters_namespaceObject = {};
__webpack_require__.r(formatters_namespaceObject);
__webpack_require__.d(formatters_namespaceObject, {
  "formatCaption": () => (formatCaption),
  "formatDay": () => (formatDay),
  "formatMonthCaption": () => (formatMonthCaption),
  "formatWeekNumber": () => (formatWeekNumber),
  "formatWeekdayName": () => (formatWeekdayName),
  "formatYearCaption": () => (formatYearCaption)
});

// NAMESPACE OBJECT: ./src/hooks/useDayPicker/labels/index.ts
var labels_namespaceObject = {};
__webpack_require__.r(labels_namespaceObject);
__webpack_require__.d(labels_namespaceObject, {
  "labelDay": () => (labelDay),
  "labelNext": () => (labelNext),
  "labelPrev": () => (labelPrev),
  "labelWeekNumber": () => (labelWeekNumber),
  "labelWeekday": () => (labelWeekday)
});

// EXTERNAL MODULE: external {"root":"React","commonjs2":"react","commonjs":"react","amd":"react"}
var external_root_React_commonjs2_react_commonjs_react_amd_react_ = __webpack_require__(698);
var external_root_React_commonjs2_react_commonjs_react_amd_react_default = /*#__PURE__*/__webpack_require__.n(external_root_React_commonjs2_react_commonjs_react_amd_react_);
// EXTERNAL MODULE: ../../node_modules/date-fns/locale/en-US/index.js
var en_US = __webpack_require__(626);
var en_US_default = /*#__PURE__*/__webpack_require__.n(en_US);
;// CONCATENATED MODULE: ./src/types/KeyCode.ts
/** Reference to KeyCodes used inside the app. */
var KeyCode;
(function (KeyCode) {
    KeyCode["ArrowLeft"] = "ArrowLeft";
    KeyCode["ArrowRight"] = "ArrowRight";
    KeyCode["ArrowUp"] = "ArrowUp";
    KeyCode["ArrowDown"] = "ArrowDown";
    KeyCode["Space"] = "Space";
    KeyCode["Enter"] = "Enter";
})(KeyCode || (KeyCode = {}));

;// CONCATENATED MODULE: ./src/types/UIElement.ts
/**
 * Represent an element or an element state of the DayPicker user interface,
 * whose style or class name can be changed using the `styles` or `classNames`
 * prop.
 *
 * ```
 * <DayPicker
 *   classNames={{ captionLast: 'my-custom-class' }}
 *   styles={{ captionLast: { color: 'red' }}}
 * />
 * ```
 */
var UIElement;
(function (UIElement) {
    /** The container element. */
    UIElement["Root"] = "root";
    /** The container element when number of months is greater than 1. */
    UIElement["RootMultipleMonths"] = "rootMultipleMonths";
    /** The caption element (showing the calendar heading and the navigation) */
    UIElement["Caption"] = "caption";
    /** The caption element when the first of multiple months */
    UIElement["CaptionFirst"] = "captionFirst";
    /** The caption element when the last of multiple months */
    UIElement["CaptionLast"] = "captionLast";
    /** The caption element is between */
    UIElement["CaptionBetween"] = "captionBetween";
    /** The container of the caption’s label (e.g. "September 2021"). */
    UIElement["CaptionLabel"] = "captionLabel";
    /** The container of the drop-downs. */
    UIElement["CaptionDropdowns"] = "dropdownsContainer";
    /** The drop-down select element. */
    UIElement["Dropdown"] = "dropdown";
    /** The drop-down to change the month. */
    UIElement["DropdownMonth"] = "dropdownMonth";
    /** The drop-down to change the year. */
    UIElement["DropdownYear"] = "dropdownYear";
    /** The icon aside the drop-down. */
    UIElement["DropdownIcon"] = "dropdownIcon";
    /** The wrapper of the months (there may be more months visualized when `numberOfMonths`). */
    UIElement["Months"] = "months";
    /** The wrapper of the table displaying the month. */
    UIElement["Month"] = "month";
    /** The table displaying the calendar. */
    UIElement["Table"] = "table";
    /** The body element of the table displaying the calendar. */
    UIElement["TBody"] = "body";
    /** The head element of the table displaying the calendar. */
    UIElement["Head"] = "head";
    /** The row element of the head. */
    UIElement["HeadRow"] = "headRow";
    /** The cell element of the head. */
    UIElement["HeadCell"] = "headCell";
    /** The navigation element. */
    UIElement["Nav"] = "nav";
    /** A navigation button. */
    UIElement["NavButton"] = "navButton";
    /** The "previous month" navigation button. */
    UIElement["NavButtonPrev"] = "navButtonPrev";
    /** The "next month" navigation button. */
    UIElement["NavButtonNext"] = "navButtonNext";
    /** The icon contained in navigation button. */
    UIElement["NavIcon"] = "navIcon";
    /** A row in the table element (each row shows a week). */
    UIElement["Row"] = "row";
    /** A row head in the table element, used to display the week numbers. */
    UIElement["RowHead"] = "rowHead";
    /** The element containing the week number */
    UIElement["WeekNumber"] = "weekNumber";
    /** The cell containing the day element. */
    UIElement["Cell"] = "cell";
    /** The day element. */
    UIElement["Day"] = "day";
    /** The day element when outside the month */
    UIElement["Outside"] = "outside";
    /** The day element when is today */
    UIElement["Today"] = "today";
})(UIElement || (UIElement = {}));

;// CONCATENATED MODULE: ./src/types/index.ts






































;// CONCATENATED MODULE: ./src/hooks/useDayPicker/defaultClassNames.ts
var _a;

/**
 * The name of the default CSS classes for the [[UIElements]].
 */
var defaultClassNames = (_a = {},
    /** Root element */
    _a[UIElement.Root] = 'rdp',
    _a[UIElement.RootMultipleMonths] = 'rdp-multiple-months',
    _a[UIElement.Months] = 'rdp-months',
    _a[UIElement.CaptionFirst] = 'rdp-month_first',
    _a[UIElement.CaptionLast] = 'rdp-month_last',
    _a[UIElement.CaptionBetween] = 'rdp-month_between',
    _a[UIElement.Caption] = 'rdp-caption',
    _a[UIElement.CaptionLabel] = 'rdp-caption-label',
    _a[UIElement.CaptionDropdowns] = 'rdp-caption-dropdowns',
    _a[UIElement.Dropdown] = 'rdp-dropdown',
    _a[UIElement.DropdownMonth] = 'rdp-dropdown_month',
    _a[UIElement.DropdownYear] = 'rdp-dropdown_year',
    // Day Component
    _a[UIElement.Day] = 'rdp-day',
    _a[UIElement.Outside] = 'rdp-day_outside',
    _a[UIElement.Today] = 'rdp-day_today',
    // Month Component
    _a[UIElement.Month] = 'rdp-month',
    _a[UIElement.Table] = 'rdp-table',
    _a[UIElement.TBody] = 'rdp-body',
    // Head Components
    _a[UIElement.Head] = 'rdp-head',
    _a[UIElement.HeadRow] = 'rdp-head-row',
    _a[UIElement.HeadCell] = 'rdp-head-cell',
    // Navigation Component
    _a[UIElement.Nav] = 'rdp-nav',
    _a[UIElement.NavButton] = 'rdp-nav-button',
    _a[UIElement.NavButtonPrev] = 'rdp-nav-button_prev',
    _a[UIElement.NavButtonNext] = 'rdp-nav-button_next',
    _a[UIElement.NavIcon] = 'rdp-nav-icon',
    _a[UIElement.DropdownIcon] = 'rdp-dropdown-icon',
    // Week Component
    _a[UIElement.Row] = 'rdp-row',
    _a[UIElement.RowHead] = 'rdp-row-head',
    _a[UIElement.WeekNumber] = 'rdp-weeknumber',
    _a[UIElement.Cell] = 'rdp-cell',
    _a);

// EXTERNAL MODULE: external {"root":"DateFns","commonjs2":"date-fns","commonjs":"date-fns","amd":"date-fns"}
var external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_ = __webpack_require__(259);
;// CONCATENATED MODULE: ./src/hooks/useDayPicker/formatters/formatCaption.ts

/**
 * The default formatter for the caption.
 */
function formatCaption(month, options) {
    return (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.format)(month, 'LLLL y', options);
}

;// CONCATENATED MODULE: ./src/hooks/useDayPicker/formatters/formatDay.ts

/**
 * The default formatter for the Day button.
 */
function formatDay(day, options) {
    return (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.format)(day, 'd', options);
}

;// CONCATENATED MODULE: ./src/hooks/useDayPicker/formatters/formatMonthCaption.ts

/**
 * The default formatter for the Month caption.
 */
function formatMonthCaption(month, options) {
    return (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.format)(month, 'LLLL', options);
}

;// CONCATENATED MODULE: ./src/hooks/useDayPicker/formatters/formatWeekNumber.ts
/**
 * The default formatter for the week number.
 */
function formatWeekNumber(weekNumber) {
    return "" + weekNumber;
}

;// CONCATENATED MODULE: ./src/hooks/useDayPicker/formatters/formatWeekdayName.ts

/**
 * The default formatter for the name of the weekday.
 */
function formatWeekdayName(weekday, options) {
    return (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.format)(weekday, 'cccccc', options);
}

;// CONCATENATED MODULE: ./src/hooks/useDayPicker/formatters/formatYearCaption.ts

/**
 * The default formatter for the Year caption.
 */
function formatYearCaption(year, options) {
    return (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.format)(year, 'yyyy', options);
}

;// CONCATENATED MODULE: ./src/hooks/useDayPicker/formatters/index.ts







;// CONCATENATED MODULE: ./src/hooks/useDayPicker/labels/labelDay.ts

/**
 * The default ARIA label for the day button.
 */
var labelDay = function (day, options) {
    return (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.format)(day, 'PPPP', options);
};

;// CONCATENATED MODULE: ./src/hooks/useDayPicker/labels/labelNext.ts

/**
 * The default ARIA label for next month button in navigation
 */
var labelNext = function (month, options) {
    return "Go to next month: " + (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.format)(month, 'LLLL Y', options);
};

;// CONCATENATED MODULE: ./src/hooks/useDayPicker/labels/labelPrev.ts

/**
 * The default ARIA label for previous month button in navigation
 */
var labelPrev = function (month, options) {
    return "Go to previous month: " + (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.format)(month, 'LLLL Y', options);
};

;// CONCATENATED MODULE: ./src/hooks/useDayPicker/labels/labelWeekNumber.ts
/**
 * The default ARIA label for the WeekNumber element.
 */
var labelWeekNumber = function (n) {
    return "Week n. " + n;
};

;// CONCATENATED MODULE: ./src/hooks/useDayPicker/labels/labelWeekday.ts

/**
 * The default ARIA label for the Weekday element.
 */
var labelWeekday = function (day, options) {
    return (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.format)(day, 'ccc', options);
};

;// CONCATENATED MODULE: ./src/hooks/useDayPicker/labels/index.ts






;// CONCATENATED MODULE: ./src/hooks/useDayPicker/utils/getWeekdays.ts

/**
 * Generate a series of 7 days, starting from the week, to use for formatting
 * the weekday names (Monday, Tuesday, etc.).
 */
function getWeekdays(locale) {
    var start = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.startOfWeek)(new Date(), { locale: locale });
    var days = [];
    for (var i = 0; i < 7; i++) {
        var day = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.addDays)(start, i);
        days.push(day);
    }
    return days;
}

;// CONCATENATED MODULE: ./src/hooks/useDayPicker/utils/parseFromToProps.ts

/**
 * Build the `fromDate` and `toDate` context values, given the fromMonth/toMonth
 * or fromYear/toYear.
 */
function parseFromToProps(props) {
    // Merge the from*/to* props into fromDate/toDate
    var fromDate = props.fromDate;
    if (props.fromMonth) {
        fromDate = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.startOfMonth)(props.fromMonth);
    }
    else if (props.fromYear) {
        fromDate = new Date(props.fromYear, 0, 1);
    }
    var toDate = props.toDate;
    if (props.toMonth) {
        toDate = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.startOfMonth)(props.toMonth);
    }
    else if (props.toYear) {
        toDate = new Date(props.toYear, 11, 31);
    }
    return { fromDate: fromDate, toDate: toDate };
}

;// CONCATENATED MODULE: ./src/hooks/useDayPicker/DayPickerContext.tsx
var __assign = (undefined && undefined.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (undefined && undefined.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};








/**
 * The DayPickerContext is a context to share props and settings within the
 * internal components. It set the defaults values, parses some props, and
 * perform one-time calculation required to render the days.
 */
var DayPickerContext = external_root_React_commonjs2_react_commonjs_react_amd_react_.createContext(undefined);
/**
 * The provider for the [[DayPickerContext]]. Must wrap the DayPicker’s root.
 */
var DayPickerProvider = function (_a) {
    var _b, _c, _d, _e, _f, _g;
    var initialProps = _a.initialProps, children = _a.children;
    var _h = parseFromToProps(initialProps), fromDate = _h.fromDate, toDate = _h.toDate;
    var locale = initialProps.locale || (en_US_default());
    var numberOfMonths = (_b = initialProps.numberOfMonths) !== null && _b !== void 0 ? _b : 1;
    var today = (_c = initialProps.today) !== null && _c !== void 0 ? _c : new Date();
    var month = initialProps.month;
    var weekdays = getWeekdays(locale);
    // Default selection mode. If using `selected` prop, it is uncontrolled
    var mode = (_d = initialProps.mode) !== null && _d !== void 0 ? _d : 'single';
    if (initialProps.selected)
        mode = 'uncontrolled';
    // Default caption layout. If calendar navigation is unlimited it must be
    // always `buttons` as we cannot display infinite options in the dropdown.
    var captionLayout = (_e = initialProps.captionLayout) !== null && _e !== void 0 ? _e : 'buttons';
    if (!fromDate && !toDate)
        captionLayout = 'buttons';
    // Set defaults from modifiers shortcuts props
    var modifiers = initialProps.modifiers || {};
    if (initialProps.selected)
        modifiers.selected = initialProps.selected;
    if (initialProps.hidden)
        modifiers.hidden = initialProps.hidden;
    modifiers.disabled = [];
    if (initialProps.disabled) {
        if (Array.isArray(initialProps.disabled))
            modifiers.disabled = __spreadArrays(initialProps.disabled);
        else
            modifiers.disabled = [initialProps.disabled];
    }
    // Disable days before/after from/toDate
    if (fromDate)
        modifiers.disabled.push({ before: fromDate });
    if (toDate)
        modifiers.disabled.push({ after: toDate });
    var context = __assign(__assign({}, initialProps), { modifierPrefix: 'rdp-day_', numberOfMonths: numberOfMonths,
        fromDate: fromDate,
        toDate: toDate,
        captionLayout: captionLayout,
        mode: mode,
        month: month,
        today: today,
        locale: locale,
        weekdays: weekdays, modifierClassNames: (_f = initialProps.modifierClassNames) !== null && _f !== void 0 ? _f : {}, styles: (_g = initialProps.styles) !== null && _g !== void 0 ? _g : {}, modifiers: modifiers, classNames: __assign(__assign({}, defaultClassNames), initialProps.classNames), formatters: __assign(__assign({}, formatters_namespaceObject), initialProps.formatters), labels: __assign(__assign({}, labels_namespaceObject), initialProps.labels), components: __assign({ Day: Day, Dropdown: Dropdown, Head: Head, Row: Row, WeekNumber: WeekNumber }, initialProps.components) });
    return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement(DayPickerContext.Provider, { value: context }, children));
};

;// CONCATENATED MODULE: ./src/hooks/useDayPicker/useDayPicker.ts


/**
 * Return the [[DayPickerContext]].
 *
 * Use the DayPickerContext to get the props and other values directly from the
 * internal components.
 */
function useDayPicker() {
    var context = external_root_React_commonjs2_react_commonjs_react_amd_react_default().useContext(DayPickerContext);
    if (!context) {
        throw new Error('useDayPickerContext must be used within a DayPickerProvider');
    }
    return context;
}

;// CONCATENATED MODULE: ./src/hooks/useDayPicker/index.ts



;// CONCATENATED MODULE: ./src/hooks/useSelection/useSelectMultiple.ts
var useSelectMultiple_spreadArrays = (undefined && undefined.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


/** Hook to handle multiple selections. */
function useMultipleSelect(mode, defaultValue, required, callback) {
    if (required === void 0) { required = false; }
    var initialValue = mode === 'multiple' && defaultValue ? defaultValue : [];
    var _a = (0,external_root_React_commonjs2_react_commonjs_react_amd_react_.useState)(initialValue), selected = _a[0], setSelected = _a[1];
    var handleClick = function (day, modifiers, e) {
        setSelected(function (currentValue) {
            var newValue = useSelectMultiple_spreadArrays(currentValue);
            if (modifiers.selected) {
                if (required && currentValue.length === 1) {
                    return newValue;
                }
                var index = currentValue.findIndex(function (value) { return (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.isSameDay)(day, value); });
                newValue.splice(index, 1);
            }
            else {
                newValue.push(day);
            }
            callback === null || callback === void 0 ? void 0 : callback(newValue, day, modifiers, e);
            return newValue;
        });
    };
    var reset = function () {
        setSelected(initialValue);
    };
    return { selected: selected, onDayClick: handleClick, reset: reset };
}

;// CONCATENATED MODULE: ./src/hooks/useSelection/utils/addToRange.ts

/**
 * Add a day to an existing range.
 *
 * The returned range takes in account the `undefined` values and if the added
 * day is already present in the range.
 */
function addToRange(day, range, required) {
    if (required === void 0) { required = false; }
    var _a = range || {}, from = _a.from, to = _a.to;
    if (!from) {
        return { from: day };
    }
    if (!required && !to && (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.isSameDay)(from, day)) {
        return undefined;
    }
    if (!to && (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.isBefore)(day, from)) {
        return { from: day, to: from };
    }
    if (!to) {
        return { from: from, to: day };
    }
    if ((0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.isSameDay)(to, day)) {
        return { from: to };
    }
    if ((0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.isAfter)(from, day)) {
        return { from: day, to: to };
    }
    return { from: from, to: day };
}

;// CONCATENATED MODULE: ./src/hooks/useSelection/useSelectRange.ts


/** Hook to handle range selections. */
function useRangeSelect(mode, defaultValue, required, callback) {
    if (required === void 0) { required = false; }
    var initialValue = mode === 'range' && defaultValue ? defaultValue : undefined;
    var _a = (0,external_root_React_commonjs2_react_commonjs_react_amd_react_.useState)(initialValue), selected = _a[0], setSelected = _a[1];
    var onDayClick = function (day, modifiers, e) {
        setSelected(function (currentValue) {
            var newValue = addToRange(day, currentValue, required);
            callback === null || callback === void 0 ? void 0 : callback(newValue, day, modifiers, e);
            setSelected(newValue);
            return newValue;
        });
        return;
    };
    var reset = function () {
        setSelected(initialValue || undefined);
    };
    return { selected: selected, onDayClick: onDayClick, reset: reset };
}

;// CONCATENATED MODULE: ./src/hooks/useSelection/useSingleSelect.ts

/** Hook to handle single selections. */
function useSingleSelect(mode, defaultValue, required, callback) {
    if (required === void 0) { required = false; }
    var initialValue = mode === 'single' && defaultValue ? defaultValue : undefined;
    var _a = (0,external_root_React_commonjs2_react_commonjs_react_amd_react_.useState)(initialValue), selected = _a[0], setSelected = _a[1];
    var onDayClick = function (day, modifiers, e) {
        if (modifiers.selected) {
            if (!required) {
                setSelected(undefined);
                callback === null || callback === void 0 ? void 0 : callback(undefined, day, modifiers, e);
            }
            return;
        }
        setSelected(day);
        callback === null || callback === void 0 ? void 0 : callback(day, day, modifiers, e);
    };
    var reset = function () {
        setSelected(initialValue);
    };
    return { selected: selected, onDayClick: onDayClick, reset: reset };
}

;// CONCATENATED MODULE: ./src/hooks/useSelection/SelectionContext.tsx





var SelectionContext = external_root_React_commonjs2_react_commonjs_react_amd_react_.createContext(undefined);
/**
 * Provides the setters and values for the controlled selection modes.
 */
var SelectionProvider = function (props) {
    var dayPickerProps = useDayPicker();
    var single = useSingleSelect('single', dayPickerProps.defaultSelected, dayPickerProps.required, dayPickerProps.onSelect);
    var multiple = useMultipleSelect('multiple', dayPickerProps.defaultSelected, dayPickerProps.required, dayPickerProps.onSelectMultiple);
    var range = useRangeSelect('range', dayPickerProps.defaultSelected, dayPickerProps.required, dayPickerProps.onSelectRange);
    return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement(SelectionContext.Provider, { value: { single: single, multiple: multiple, range: range } }, props.children));
};

;// CONCATENATED MODULE: ./src/hooks/useSelection/useSelection.ts


/** Return the context for the controlled mode selection. */
function useSelection() {
    var context = external_root_React_commonjs2_react_commonjs_react_amd_react_default().useContext(SelectionContext);
    if (!context) {
        throw new Error('useSelection must be used within a SelectionProvider');
    }
    return context;
}

;// CONCATENATED MODULE: ./src/hooks/useSelection/index.ts



;// CONCATENATED MODULE: ./src/hooks/useModifiers/utils/matchAfter.ts

function matchAfter(day, matcher) {
    if (!('after' in matcher) || 'before' in matcher)
        return false;
    return (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.differenceInCalendarDays)(day, matcher.after) > 0;
}

;// CONCATENATED MODULE: ./src/hooks/useModifiers/utils/matchBefore.ts

function matchBefore(day, matcher) {
    if (!('before' in matcher) || 'after' in matcher)
        return false;
    return (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.differenceInCalendarDays)(day, matcher.before) < 0;
}

;// CONCATENATED MODULE: ./src/hooks/useModifiers/utils/matchBeforeAndAfter.ts

function matchBeforeAndAfter(day, matcher) {
    if (!('before' in matcher) || !('after' in matcher))
        return false;
    return ((0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.differenceInCalendarDays)(day, matcher.before) < 0 &&
        (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.differenceInCalendarDays)(day, matcher.after) > 0);
}

;// CONCATENATED MODULE: ./src/hooks/useModifiers/utils/matchDate.ts

function matchDate(day, matcher) {
    if (!(matcher instanceof Date))
        return false;
    return (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.isSameDay)(day, matcher);
}

;// CONCATENATED MODULE: ./src/hooks/useModifiers/utils/matchDaysOfWeek.ts
function matchDaysOfWeek(day, matcher) {
    if (!('daysOfWeek' in matcher))
        return false;
    return matcher.daysOfWeek.includes(day.getDay());
}

;// CONCATENATED MODULE: ./src/hooks/useModifiers/utils/matchFunction.ts
function matchFunction(day, matcher) {
    if (!(matcher instanceof Function))
        return false;
    return matcher(day);
}

;// CONCATENATED MODULE: ./src/hooks/useModifiers/utils/matchRange.ts

function matchRange(day, matcher) {
    var _a;
    if (!('from' in matcher))
        return false;
    if (!matcher.from)
        return false;
    var from = matcher.from, to = matcher.to;
    // Matches { from: <Date> }
    if (!to && from && (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.isSameDay)(from, day))
        return true;
    if (!to)
        return false;
    // Invert the case where "to" is before "from"
    if (matcher.to && (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.differenceInCalendarDays)(matcher.to, matcher.from) < 0) {
        _a = [matcher.to, matcher.from], from = _a[0], to = _a[1];
    }
    return ((0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.differenceInCalendarDays)(day, from) >= 0 &&
        (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.differenceInCalendarDays)(to, day) >= 0);
}

;// CONCATENATED MODULE: ./src/hooks/useModifiers/utils/isMatch.ts







/**
 * Returns true when the day matches against the given matcher. Supports few
 * basic matchers.
 */
function isMatch(day, matcher) {
    if (!matcher)
        return false;
    var matchers;
    if (Array.isArray(matcher)) {
        matchers = matcher;
    }
    else {
        matchers = [matcher];
    }
    return matchers.some(function (dayMatcher) {
        if (!dayMatcher)
            return false;
        return (
        // Precedence shouldn't be important here
        matchDate(day, dayMatcher) ||
            matchBeforeAndAfter(day, dayMatcher) ||
            matchBefore(day, dayMatcher) ||
            matchAfter(day, dayMatcher) ||
            matchRange(day, dayMatcher) ||
            matchDaysOfWeek(day, dayMatcher) ||
            matchFunction(day, dayMatcher));
    });
}

;// CONCATENATED MODULE: ./src/hooks/useModifiers/utils/getModifierStatus.ts

/**
 * Return the status of the modifiers for the given day,
 */
function getModifierStatus(day, 
/** The modifiers for the given day. */
modifiers) {
    var modifiersList = Object.keys(modifiers).reduce(function (previousValue, key) {
        var modifier = modifiers[key];
        if (isMatch(day, modifier)) {
            previousValue.push(key);
        }
        return previousValue;
    }, []);
    var modifiersStatus = {};
    modifiersList.forEach(function (modifier) { return (modifiersStatus[modifier] = true); });
    return modifiersStatus;
}

;// CONCATENATED MODULE: ./src/hooks/useModifiers/useModifiers.ts



/** Return the status for the modifiers given the specified date */
function useModifiers(date) {
    var context = useDayPicker();
    var selection = useSelection();
    var modifiers = Object.assign({}, context.modifiers);
    if (context.mode !== 'uncontrolled') {
        var _a = selection !== null && selection !== void 0 ? selection : {}, single = _a.single, multiple = _a.multiple, range = _a.range;
        switch (context.mode) {
            case 'range':
                if (!range.selected)
                    break;
                modifiers.selected = range.selected;
                modifiers['range-middle'] = {
                    after: range.selected.from,
                    before: range.selected.to
                };
                modifiers['range-start'] = range.selected.from;
                if (range.selected.to)
                    modifiers['range-end'] = range.selected.to;
                break;
            case 'multiple':
                if (!multiple.selected)
                    break;
                modifiers.selected = multiple.selected;
                break;
            default:
            case 'single':
                if (!single.selected)
                    break;
                modifiers.selected = single.selected;
                break;
        }
    }
    var status = getModifierStatus(date, modifiers);
    return status;
}

;// CONCATENATED MODULE: ./src/hooks/useModifiers/index.ts


;// CONCATENATED MODULE: ./src/hooks/useInput/useInput.ts


/** @private */
function isValidDate(day) {
    return !isNaN(day.getTime());
}
/**
 * Return the props for binding an input field with DayPicker.
 *
 * **Example**
 *
 * ```
 * function Example() {
 *   const { dayPickerProps, inputProps } = useInput(new Date(), 'yyyy-MM-dd');
 *   return (
 *     <>
 *       <p>
 *         Type a day or pick one from the calendar:
 *         <input {...inputProps} placeholder="YYYY-MM-DD" />
 *       </p>
 *       <DayPicker {...dayPickerProps} />
 *     </>
 *   );
 * }
 * ```
 */
function useInput(initialDay, formatStr, options) {
    var _a;
    // Defaults from options
    var locale = options === null || options === void 0 ? void 0 : options.locale;
    var required = (_a = options === null || options === void 0 ? void 0 : options.required) !== null && _a !== void 0 ? _a : false;
    // Shortcut to the DateFns functions
    var formatDay = function (day) { return (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.format)(day, formatStr, { locale: locale }); };
    var parseValue = function (value) {
        return (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.parse)(value, formatStr, new Date(), { locale: locale });
    };
    // The initial value of the input field
    var initialValue = initialDay ? formatDay(initialDay) : '';
    // Initialize state
    var _b = external_root_React_commonjs2_react_commonjs_react_amd_react_.useState(initialDay), selected = _b[0], setSelected = _b[1];
    var _c = external_root_React_commonjs2_react_commonjs_react_amd_react_.useState(initialValue), value = _c[0], setValue = _c[1];
    var _d = external_root_React_commonjs2_react_commonjs_react_amd_react_.useState(initialDay !== null && initialDay !== void 0 ? initialDay : new Date()), month = _d[0], setMonth = _d[1];
    var onDayClick = function (day) {
        setSelected(day);
        setValue(formatDay(day));
    };
    var onMonthChange = function (month) {
        setMonth(month);
    };
    // When changing the input field, save its value in state and check if the
    // string is a valid date. If it is a valid day, set it as selected and update
    // the calendar’s month.
    var onChange = function (e) {
        setValue(e.target.value);
        var day = parseValue(e.target.value);
        if (!isValidDate(day)) {
            setSelected(undefined);
            return;
        }
        setSelected(day);
        setMonth(day);
    };
    // Special case for _required_ fields: on blur, if the value of the input is not
    // a valid date, reset the calendar and the input value.
    var onBlur = function (e) {
        var _a;
        var day = parseValue(e.target.value);
        if ((_a = !required) !== null && _a !== void 0 ? _a : isValidDate(day)) {
            return;
        }
        setSelected(initialDay);
        setMonth(initialDay !== null && initialDay !== void 0 ? initialDay : new Date());
        setValue(initialValue !== null && initialValue !== void 0 ? initialValue : '');
    };
    // When focusing, make sure DayPicker visualizes the month of the date in the
    // input field.
    var onFocus = function (e) {
        if (e.target.value) {
            var day = parseValue(e.target.value);
            if (isValidDate(day)) {
                setMonth(day);
            }
            return;
        }
        setSelected(initialDay);
        setMonth(initialDay !== null && initialDay !== void 0 ? initialDay : new Date());
        setValue(initialValue !== null && initialValue !== void 0 ? initialValue : '');
    };
    return {
        setMonth: setMonth,
        setValue: setValue,
        dayPickerProps: {
            month: month,
            selected: selected,
            onDayClick: onDayClick,
            onMonthChange: onMonthChange,
            mode: 'uncontrolled'
        },
        inputProps: {
            value: value,
            onChange: onChange,
            onFocus: onFocus,
            onBlur: onBlur
        }
    };
}

;// CONCATENATED MODULE: ./src/hooks/useInput/index.ts


;// CONCATENATED MODULE: ./src/hooks/useNavigation/utils/getDisplayMonths.ts

/**
 * Return the months to display in the component according to the number of
 * months and the from/to date.
 */
function getDisplayMonths(month, _a) {
    var toDate = _a.toDate, fromDate = _a.fromDate, reverseMonths = _a.reverseMonths, numberOfMonths = _a.numberOfMonths;
    var start = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.startOfMonth)(month);
    var end = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.startOfMonth)((0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.addMonths)(start, numberOfMonths));
    var monthsDiff = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.differenceInMonths)(end, start);
    var months = [];
    for (var i = 0; i < monthsDiff; i++) {
        var nextMonth = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.addMonths)(start, i);
        if (toDate && nextMonth > (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.startOfMonth)(toDate))
            continue;
        if (fromDate && nextMonth < (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.startOfMonth)(fromDate))
            continue;
        months.push(nextMonth);
    }
    if (reverseMonths)
        months = months.reverse();
    return months;
}

;// CONCATENATED MODULE: ./src/hooks/useNavigation/NavigationContext.tsx




/** The navigation context holds values and setters for navigating between the
 * calendars. */
var NavigationContext = external_root_React_commonjs2_react_commonjs_react_amd_react_.createContext(undefined);
/** Provides the values for the [[NavigationContext]]. */
var NavigationProvider = function (_a) {
    var children = _a.children;
    var context = useDayPicker();
    var _b = external_root_React_commonjs2_react_commonjs_react_amd_react_.useState(context.month || context.defaultMonth || context.today), month = _b[0], setMonthInternal = _b[1];
    var setMonth = function (date) {
        if (context.disableNavigation)
            return;
        setMonthInternal(date);
    };
    external_root_React_commonjs2_react_commonjs_react_amd_react_.useEffect(function () {
        if (!context.month)
            return;
        if ((0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.isSameMonth)(context.month, month))
            return;
        setMonth(context.month);
    }, [context.month]);
    var displayMonths = getDisplayMonths(month, context);
    return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement(NavigationContext.Provider, { value: { month: month, displayMonths: displayMonths, setMonth: setMonth } }, children));
};

;// CONCATENATED MODULE: ./src/hooks/useNavigation/useNavigation.ts


/** Return the [[NavigationContext]] for handing the navigation. */
function useNavigation() {
    var context = external_root_React_commonjs2_react_commonjs_react_amd_react_.useContext(NavigationContext);
    if (!context) {
        throw new Error('useNavigation must be used within a NavigationProvider');
    }
    return context;
}

;// CONCATENATED MODULE: ./src/hooks/useNavigation/index.ts



;// CONCATENATED MODULE: ./src/hooks/index.ts






;// CONCATENATED MODULE: ./src/hooks/useNavigation/utils/getPrevNextMonths.ts

/**
 * Returns the next and the previous month that the user can navigate to.
 */
function getPrevNextMonths(month, options) {
    var fromDate = options.fromDate, toDate = options.toDate, pagedNavigation = options.pagedNavigation, numberOfMonths = options.numberOfMonths, disableNavigation = options.disableNavigation;
    if (disableNavigation) {
        return [undefined, undefined];
    }
    var add = pagedNavigation ? numberOfMonths : 1;
    var currentMonth = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.startOfMonth)(month !== null && month !== void 0 ? month : options.today);
    var prevMonth;
    if (!fromDate || currentMonth > (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.startOfMonth)(fromDate)) {
        prevMonth = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.addMonths)(currentMonth, add * -1);
    }
    var nextMonth;
    if (!toDate ||
        (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.addMonths)(currentMonth, numberOfMonths) <= (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.startOfMonth)(toDate)) {
        nextMonth = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.addMonths)(currentMonth, add);
    }
    return [prevMonth, nextMonth];
}

;// CONCATENATED MODULE: ./src/components/Caption/Caption.tsx





/**
 * Render the caption of a month, which includes title and navigation buttons.
 * The caption has a different layout when setting the `numberOfMonths` prop.
 */
function Caption(props) {
    var displayMonth = props.displayMonth, isFirst = props.isFirst, isLast = props.isLast, isBetween = props.isBetween;
    var context = useDayPicker();
    var dir = context.dir, locale = context.locale, classNames = context.classNames, numberOfMonths = context.numberOfMonths, disableNavigation = context.disableNavigation, styles = context.styles, captionLayout = context.captionLayout, _a = context.labels, labelPrev = _a.labelPrev, labelNext = _a.labelNext, formatCaption = context.formatters.formatCaption, onMonthChange = context.onMonthChange;
    var _b = useNavigation(), month = _b.month, setMonth = _b.setMonth;
    var _c = getPrevNextMonths(month, context), prevMonth = _c[0], nextMonth = _c[1];
    var onPrevClick = function (e) {
        if (!prevMonth)
            return;
        setMonth(prevMonth);
        onMonthChange === null || onMonthChange === void 0 ? void 0 : onMonthChange(prevMonth);
    };
    var onNextClick = function (e) {
        if (!nextMonth)
            return;
        setMonth(nextMonth);
        onMonthChange === null || onMonthChange === void 0 ? void 0 : onMonthChange(nextMonth);
    };
    var handleMonthChange = function (newMonth) {
        setMonth(newMonth);
        onMonthChange === null || onMonthChange === void 0 ? void 0 : onMonthChange(newMonth);
    };
    var prevButton = (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("button", { key: "prev", "aria-label": labelPrev(displayMonth, { locale: locale }), className: [classNames[UIElement.NavButton], classNames[UIElement.NavButtonPrev]].join(' '), style: styles[UIElement.NavButtonPrev], disabled: !prevMonth, onClick: dir === 'rtl' ? onNextClick : onPrevClick },
        external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement(IconPrev, { className: classNames[UIElement.NavIcon], style: styles[UIElement.NavIcon] })));
    var nextButton = (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("button", { key: "next", "aria-label": labelNext(displayMonth, { locale: locale }), className: [classNames[UIElement.NavButton], classNames[UIElement.NavButtonNext]].join(' '), disabled: !nextMonth, onClick: dir === 'rtl' ? onPrevClick : onNextClick, style: styles[UIElement.NavButtonNext] },
        external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement(IconNext, { className: classNames[UIElement.NavIcon], style: styles[UIElement.NavIcon] })));
    var caption = (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("div", { key: "caption", className: classNames[UIElement.CaptionLabel], style: styles[UIElement.CaptionLabel], "aria-live": "polite" }, formatCaption(displayMonth, { locale: locale })));
    var buttons = [prevButton, nextButton];
    if (dir === 'rtl')
        buttons.reverse();
    if (isFirst)
        buttons = [prevButton]; // show only the prev button
    if (isLast)
        buttons = [nextButton]; // show only the next button
    if (isBetween)
        buttons = []; // do not show buttons at all
    var nav = (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("span", { key: "nav", className: classNames[UIElement.Nav], style: styles[UIElement.Nav] }, buttons));
    return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("div", { className: classNames[UIElement.Caption], style: styles[UIElement.Caption] }, disableNavigation ? (caption) : (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement(external_root_React_commonjs2_react_commonjs_react_amd_react_.Fragment, null,
        captionLayout === 'dropdown' && (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("div", { className: classNames[UIElement.CaptionDropdowns], style: styles[UIElement.CaptionDropdowns] },
            external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement(MonthsDropdown, { onChange: handleMonthChange, displayMonth: displayMonth }),
            external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement(YearsDropdown, { onChange: handleMonthChange, displayMonth: displayMonth }))),
        captionLayout === 'buttons' &&
            numberOfMonths === 1 && [caption, nav],
        captionLayout === 'buttons' && isFirst && [nav, caption],
        captionLayout === 'buttons' && isLast && [caption, nav],
        captionLayout === 'buttons' && isBetween && caption))));
}

;// CONCATENATED MODULE: ./src/components/Caption/index.ts


;// CONCATENATED MODULE: ./src/hooks/useFocus/FocusContext.tsx





/**
 * The focus context holds values and method to handle the focused day via
 * keyboard navigation.
 */
var FocusContext = external_root_React_commonjs2_react_commonjs_react_amd_react_.createContext(undefined);
/** Enable the FocusContext to handle the focus when navigating via keyboard. */
var FocusProvider = function (_a) {
    var children = _a.children;
    var _b = external_root_React_commonjs2_react_commonjs_react_amd_react_.useState(), focusedDay = _b[0], setDay = _b[1];
    var _c = useNavigation(), setMonth = _c.setMonth, displayMonths = _c.displayMonths;
    var _d = useDayPicker(), modifiers = _d.modifiers, numberOfMonths = _d.numberOfMonths;
    var blur = function () { return setDay(undefined); };
    var focus = function (date) { return setDay(date); };
    var switchMonth = function (date, offset) {
        if (displayMonths.some(function (m) { return (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.isSameMonth)(date, m); }))
            return;
        if (offset < 0) {
            setMonth((0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.addMonths)(date, 1 + offset));
        }
        else {
            setMonth(date);
        }
    };
    var isFocusable = function (day) {
        if (isMatch(day, modifiers.disabled))
            return false;
        return true;
    };
    var focusDayBefore = function () {
        if (!focusedDay)
            return;
        var before = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.addDays)(focusedDay, -1);
        if (!isFocusable(before))
            return;
        setDay(before);
        switchMonth(before, numberOfMonths * -1);
    };
    var focusDayAfter = function () {
        if (!focusedDay)
            return;
        var after = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.addDays)(focusedDay, 1);
        if (!isFocusable(after))
            return;
        setDay(after);
        switchMonth(after, numberOfMonths);
    };
    var focusDayUp = function () {
        if (!focusedDay)
            return;
        var up = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.addWeeks)(focusedDay, -1);
        if (!isFocusable(up))
            return;
        setDay(up);
        switchMonth(up, numberOfMonths * -1);
    };
    var focusDayDown = function () {
        if (!focusedDay)
            return;
        var down = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.addWeeks)(focusedDay, 1);
        if (!isFocusable(down))
            return;
        setDay(down);
        switchMonth(down, numberOfMonths);
    };
    var setters = {
        blur: blur,
        focus: focus,
        focusDayAfter: focusDayAfter,
        focusDayBefore: focusDayBefore,
        focusDayUp: focusDayUp,
        focusDayDown: focusDayDown
    };
    return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement(FocusContext.Provider, { value: [focusedDay, setters] }, children));
};

;// CONCATENATED MODULE: ./src/hooks/useFocus/useFocus.ts


/** Return the context for handling focus via keyboard. */
function useFocus() {
    var context = external_root_React_commonjs2_react_commonjs_react_amd_react_.useContext(FocusContext);
    if (!context) {
        throw new Error('useFocus must be used within a FocusProvider');
    }
    return context;
}

;// CONCATENATED MODULE: ./src/hooks/useFocus/index.ts



;// CONCATENATED MODULE: ./src/components/Day/utils/createHandlers.ts
function createHandlers(date, modifierStatus, context) {
    var onKeyUp = function (e) {
        var _a;
        (_a = context.onDayKeyUp) === null || _a === void 0 ? void 0 : _a.call(context, date, modifierStatus, e);
    };
    var onMouseEnter = function (e) {
        var _a;
        (_a = context.onDayMouseEnter) === null || _a === void 0 ? void 0 : _a.call(context, date, modifierStatus, e);
    };
    var onMouseLeave = function (e) {
        var _a;
        (_a = context.onDayMouseLeave) === null || _a === void 0 ? void 0 : _a.call(context, date, modifierStatus, e);
    };
    var onTouchCancel = function (e) {
        var _a;
        (_a = context.onDayTouchCancel) === null || _a === void 0 ? void 0 : _a.call(context, date, modifierStatus, e);
    };
    var onTouchEnd = function (e) {
        var _a;
        (_a = context.onDayTouchEnd) === null || _a === void 0 ? void 0 : _a.call(context, date, modifierStatus, e);
    };
    var onTouchMove = function (e) {
        var _a;
        (_a = context.onDayTouchMove) === null || _a === void 0 ? void 0 : _a.call(context, date, modifierStatus, e);
    };
    var onTouchStart = function (e) {
        var _a;
        (_a = context.onDayTouchStart) === null || _a === void 0 ? void 0 : _a.call(context, date, modifierStatus, e);
    };
    return {
        onKeyUp: onKeyUp,
        onMouseEnter: onMouseEnter,
        onMouseLeave: onMouseLeave,
        onTouchCancel: onTouchCancel,
        onTouchEnd: onTouchEnd,
        onTouchMove: onTouchMove,
        onTouchStart: onTouchStart
    };
}

;// CONCATENATED MODULE: ./src/components/Day/Day.tsx
var Day_assign = (undefined && undefined.__assign) || function () {
    Day_assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return Day_assign.apply(this, arguments);
};






/**
 * Render the content of a date cell, as a button or span element according to
 * its modifiers. Attaches the event handlers from DayPicker context, and manage the
 * focused date.
 */
function Day(props) {
    var buttonRef = external_root_React_commonjs2_react_commonjs_react_amd_react_.useRef(null);
    var date = props.date, displayMonth = props.displayMonth;
    var context = useDayPicker();
    var selection = useSelection();
    var status = useModifiers(date);
    var _a = useFocus(), focusedDay = _a[0], _b = _a[1], focusDayAfter = _b.focusDayAfter, focusDayBefore = _b.focusDayBefore, focusDayDown = _b.focusDayDown, focusDayUp = _b.focusDayUp, blur = _b.blur, focus = _b.focus;
    var classNames = context.classNames, formatDay = context.formatters.formatDay, labelDay = context.labels.labelDay, locale = context.locale, modifierClassNames = context.modifierClassNames, modifierPrefix = context.modifierPrefix, modifierStyles = context.modifierStyles, showOutsideDays = context.showOutsideDays, styles = context.styles, onDayClick = context.onDayClick, mode = context.mode;
    external_root_React_commonjs2_react_commonjs_react_amd_react_.useEffect(function () {
        var _a;
        if (!focusedDay)
            return;
        if ((0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.isSameDay)(focusedDay, date)) {
            (_a = buttonRef.current) === null || _a === void 0 ? void 0 : _a.focus();
        }
    }, [focusedDay]);
    if (status.hidden)
        return external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("span", null);
    var ariaLabel = labelDay(date, status, { locale: locale });
    var ariaPressed = status.selected;
    var handleClick = function (e) {
        var _a, _b;
        if (mode !== 'uncontrolled') {
            (_b = (_a = selection[mode]).onDayClick) === null || _b === void 0 ? void 0 : _b.call(_a, date, status, e);
        }
        onDayClick === null || onDayClick === void 0 ? void 0 : onDayClick(date, status, e);
    };
    var handleFocus = function (e) {
        focus(date);
    };
    var handleBlur = function (e) {
        blur();
    };
    var handleKeyDown = function (e) {
        switch (e.key) {
            case KeyCode.ArrowLeft:
                e.preventDefault();
                e.stopPropagation();
                focusDayBefore();
                break;
            case KeyCode.ArrowRight:
                e.preventDefault();
                e.stopPropagation();
                focusDayAfter();
                break;
            case KeyCode.ArrowDown:
                e.preventDefault();
                e.stopPropagation();
                focusDayDown();
                break;
            case KeyCode.ArrowUp:
                e.preventDefault();
                e.stopPropagation();
                focusDayUp();
                break;
        }
    };
    var otherEventHandlers = createHandlers(date, status, context);
    var buttonClassNames = [classNames[UIElement.Day]];
    var isOutside = !(0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.isSameMonth)(date, displayMonth);
    if (isOutside) {
        buttonClassNames.push(classNames[UIElement.Outside]);
    }
    var isToday = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.isSameDay)(date, context.today);
    if (isToday) {
        buttonClassNames.push(classNames[UIElement.Today]);
    }
    Object.keys(status)
        .filter(function (modifier) { return Boolean(status[modifier]); })
        .forEach(function (modifier) {
        if (modifierClassNames[modifier]) {
            buttonClassNames.push(modifierClassNames[modifier]);
        }
        else {
            buttonClassNames.push("" + modifierPrefix + modifier);
        }
    });
    var style = Day_assign({}, styles[UIElement.Day]);
    if (styles) {
        Object.keys(status).forEach(function (modifier) { return (style = Day_assign(Day_assign({}, style), styles[modifier])); });
    }
    if (modifierStyles) {
        Object.keys(status).forEach(function (modifier) { return (style = Day_assign(Day_assign({}, style), modifierStyles[modifier])); });
    }
    if (isOutside && !showOutsideDays)
        return external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("span", null);
    if (status.hidden)
        return external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("span", null);
    var formattedDay = formatDay(date, { locale: locale });
    if (status.disabled || isOutside) {
        return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("span", { style: style, className: buttonClassNames.join(' ') }, formattedDay));
    }
    var tabIndex = 0;
    if (focusedDay && !(0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.isSameDay)(focusedDay, date))
        tabIndex = -1;
    return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("button", Day_assign({ ref: buttonRef, "aria-label": ariaLabel, "aria-pressed": ariaPressed, style: style, className: buttonClassNames.join(' '), tabIndex: tabIndex, onClick: handleClick, onFocus: handleFocus, onBlur: handleBlur, onKeyDown: handleKeyDown }, otherEventHandlers), formattedDay));
}

;// CONCATENATED MODULE: ./src/components/Day/index.ts


;// CONCATENATED MODULE: ./src/components/DayPicker/DayPicker.tsx




/**
 * Render the date picker component.
 */
function DayPicker(props) {
    return (external_root_React_commonjs2_react_commonjs_react_amd_react_default().createElement(DayPickerProvider, { initialProps: props },
        external_root_React_commonjs2_react_commonjs_react_amd_react_default().createElement(NavigationProvider, null,
            external_root_React_commonjs2_react_commonjs_react_amd_react_default().createElement(SelectionProvider, null,
                external_root_React_commonjs2_react_commonjs_react_amd_react_default().createElement(FocusProvider, null,
                    external_root_React_commonjs2_react_commonjs_react_amd_react_default().createElement(Root, null))))));
}

;// CONCATENATED MODULE: ./src/components/DayPicker/index.ts

// export * from './DayPickerContext';
// export * from './NavigationContext';

;// CONCATENATED MODULE: ./src/components/IconDropdown/IconDropdown.tsx

/**
 * Render the icon in the styled drop-down.
 */
function IconDropdown(_a) {
    var className = _a.className, style = _a.style;
    return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("svg", { width: "8px", height: "8px", viewBox: "0 0 120 120", className: className, style: style },
        external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("path", { d: "M4.22182541,48.2218254 C8.44222828,44.0014225 15.2388494,43.9273804 19.5496459,47.9996989 L19.7781746,48.2218254 L60,88.443 L100.221825,48.2218254 C104.442228,44.0014225 111.238849,43.9273804 115.549646,47.9996989 L115.778175,48.2218254 C119.998577,52.4422283 120.07262,59.2388494 116.000301,63.5496459 L115.778175,63.7781746 L67.7781746,111.778175 C63.5577717,115.998577 56.7611506,116.07262 52.4503541,112.000301 L52.2218254,111.778175 L4.22182541,63.7781746 C-0.0739418023,59.4824074 -0.0739418023,52.5175926 4.22182541,48.2218254 Z", fill: "currentColor", fillRule: "nonzero" })));
}

;// CONCATENATED MODULE: ./src/components/IconDropdown/index.ts


;// CONCATENATED MODULE: ./src/components/Dropdown/Dropdown.tsx




/**
 * Render a dropdown component (basically, a styled HTMLSelectElement).
 */
function Dropdown(props) {
    var onChange = props.onChange, value = props.value, children = props.children, caption = props.caption, className = props.className, style = props.style;
    var _a = useDayPicker(), classNames = _a.classNames, styles = _a.styles;
    return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("div", { className: className, style: style },
        external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("select", { className: classNames[UIElement.Dropdown], style: styles[UIElement.Dropdown], value: value, onChange: onChange }, children),
        external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("div", { className: classNames[UIElement.CaptionLabel], style: styles[UIElement.CaptionLabel], "aria-hidden": "true" },
            caption,
            external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement(IconDropdown, { className: classNames[UIElement.DropdownIcon], style: styles[UIElement.DropdownIcon] }))));
}

;// CONCATENATED MODULE: ./src/components/Dropdown/index.ts


;// CONCATENATED MODULE: ./src/components/Head/Head.tsx



/**
 * Render the Head component - i.e. the table head with the weekday names.
 */
function Head() {
    var _a = useDayPicker(), classNames = _a.classNames, styles = _a.styles, showWeekNumber = _a.showWeekNumber, locale = _a.locale, formatWeekdayName = _a.formatters.formatWeekdayName, labelWeekday = _a.labels.labelWeekday, weekdays = _a.weekdays;
    return (external_root_React_commonjs2_react_commonjs_react_amd_react_default().createElement("thead", { style: styles[UIElement.Head], className: classNames[UIElement.Head] },
        external_root_React_commonjs2_react_commonjs_react_amd_react_default().createElement("tr", { style: styles[UIElement.HeadRow], className: classNames[UIElement.HeadRow] },
            showWeekNumber && (external_root_React_commonjs2_react_commonjs_react_amd_react_default().createElement("th", { style: styles[UIElement.HeadCell], className: classNames[UIElement.HeadCell] })),
            weekdays.map(function (weekday, i) { return (external_root_React_commonjs2_react_commonjs_react_amd_react_default().createElement("th", { key: i, scope: "col", className: classNames[UIElement.HeadCell], style: styles[UIElement.HeadCell], "aria-label": labelWeekday(weekday, { locale: locale }) }, formatWeekdayName(weekday, { locale: locale }))); }))));
}

;// CONCATENATED MODULE: ./src/components/Head/index.ts


;// CONCATENATED MODULE: ./src/components/IconNext/IconNext.tsx

/**
 * Render the "next month" button in the navigation.
 */
function IconNext(_a) {
    var className = _a.className, style = _a.style;
    return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("svg", { width: "16px", height: "16px", viewBox: "0 0 120 120", className: className, style: style },
        external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("path", { d: "M49.8040405,3.34314575 C46.6798462,0.218951416 41.6145263,0.218951416 38.490332,3.34314575 C35.4326099,6.40086786 35.367552,11.3179931 38.2951583,14.4548388 L38.490332,14.6568542 L83.8333725,60 L38.490332,105.343146 C35.4326099,108.400868 35.367552,113.317993 38.2951583,116.454839 L38.490332,116.656854 C41.5480541,119.714576 46.4651794,119.779634 49.602025,116.852028 L49.8040405,116.656854 L100.804041,65.6568542 C103.861763,62.5991321 103.926821,57.6820069 100.999214,54.5451612 L100.804041,54.3431458 L49.8040405,3.34314575 Z", fill: "currentColor" })));
}

;// CONCATENATED MODULE: ./src/components/IconNext/index.ts


;// CONCATENATED MODULE: ./src/components/IconPrev/IconPrev.tsx

/**
 * Render the "previous month" button in the navigation.
 */
function IconPrev(_a) {
    var className = _a.className, style = _a.style;
    return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement(external_root_React_commonjs2_react_commonjs_react_amd_react_.Fragment, null,
        external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("svg", { width: "16px", height: "16px", viewBox: "0 0 120 120", className: className, style: style },
            external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("path", { d: "M69.490332,3.34314575 C72.6145263,0.218951416 77.6798462,0.218951416 80.8040405,3.34314575 C83.8617626,6.40086786 83.9268205,11.3179931 80.9992143,14.4548388 L80.8040405,14.6568542 L35.461,60 L80.8040405,105.343146 C83.8617626,108.400868 83.9268205,113.317993 80.9992143,116.454839 L80.8040405,116.656854 C77.7463184,119.714576 72.8291931,119.779634 69.6923475,116.852028 L69.490332,116.656854 L18.490332,65.6568542 C15.4326099,62.5991321 15.367552,57.6820069 18.2951583,54.5451612 L18.490332,54.3431458 L69.490332,3.34314575 Z", fill: "currentColor", fillRule: "nonzero" }))));
}

;// CONCATENATED MODULE: ./src/components/IconPrev/index.ts


;// CONCATENATED MODULE: ./src/components/MonthsDropdown/MonthsDropdown.tsx




/**
 * Render the dropdown to navigate between months.
 */
function MonthsDropdown(props) {
    var displayMonth = props.displayMonth;
    var _a = useDayPicker(), fromDate = _a.fromDate, toDate = _a.toDate, styles = _a.styles, locale = _a.locale, formatMonthCaption = _a.formatters.formatMonthCaption, classNames = _a.classNames, Dropdown = _a.components.Dropdown;
    var dropdownMonths = [];
    if (fromDate && toDate) {
        if ((0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.isSameYear)(fromDate, toDate)) {
            // only display the months included in the range
            for (var month = fromDate.getMonth(); month <= toDate.getMonth(); month++) {
                dropdownMonths.push((0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.setMonth)((0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.startOfMonth)(fromDate), month));
            }
        }
        else {
            // display all the 12 months
            for (var month = 0; month <= 11; month++) {
                var anyDate = new Date(); // any date is OK, we just need the year
                dropdownMonths.push((0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.setMonth)((0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.startOfMonth)(anyDate), month));
            }
        }
    }
    var handleChange = function (e) {
        var newMonth = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.setMonth)(new Date(displayMonth), Number(e.target.value));
        props.onChange(newMonth);
    };
    return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement(Dropdown, { className: classNames[UIElement.DropdownMonth], style: styles[UIElement.DropdownMonth], onChange: handleChange, value: displayMonth.getMonth(), caption: formatMonthCaption(displayMonth, { locale: locale }) }, dropdownMonths.map(function (m) { return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("option", { key: m.getMonth(), value: m.getMonth() }, formatMonthCaption(m, { locale: locale }))); })));
}

;// CONCATENATED MODULE: ./src/components/MonthsDropdown/index.ts


;// CONCATENATED MODULE: ./src/components/Root/Root.tsx
var Root_assign = (undefined && undefined.__assign) || function () {
    Root_assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return Root_assign.apply(this, arguments);
};




/**
 * Render the container with the months and their captions. The number of months
 * rendered depends by the `numberOfMonths` prop.
 */
function Root(props) {
    var className = props.className, style = props.style;
    var _a = useDayPicker(), dir = _a.dir, classNames = _a.classNames, styles = _a.styles, numberOfMonths = _a.numberOfMonths;
    var displayMonths = useNavigation().displayMonths;
    var rootClassNames = [classNames[UIElement.Root]];
    if (numberOfMonths > 1) {
        rootClassNames.push(classNames[UIElement.RootMultipleMonths]);
    }
    if (className)
        rootClassNames.concat(className.split(' '));
    var renderMonth = function (displayMonth, displayIndex) {
        var _a;
        var className = [classNames[UIElement.Month]];
        var style = Root_assign({}, styles[UIElement.Month]);
        var isFirst = numberOfMonths > 1 && displayIndex === 0;
        var isLast = numberOfMonths > 1 && displayIndex === displayMonths.length - 1;
        if (dir === 'rtl')
            _a = [isFirst, isLast], isLast = _a[0], isFirst = _a[1];
        var isBetween = numberOfMonths > 1 && !isFirst && !isLast;
        if (isFirst) {
            className.push(classNames[UIElement.CaptionFirst]);
            Object.assign(style, styles[UIElement.CaptionFirst]);
        }
        if (isLast)
            className.push(classNames[UIElement.CaptionLast]);
        if (isBetween)
            className.push(classNames[UIElement.CaptionBetween]);
        return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("div", { key: displayIndex, className: className.join(' '), style: style },
            external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement(Caption, { displayMonth: displayMonth, displayIndex: displayIndex, isFirst: isFirst, isLast: isLast, isBetween: isBetween }),
            external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement(Table, { displayMonth: displayMonth })));
    };
    return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("div", { className: rootClassNames.join(' '), style: Root_assign(Root_assign({}, styles[UIElement.Root]), style), dir: dir },
        external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("div", { className: classNames[UIElement.Months], style: styles[UIElement.Months] }, displayMonths.map(renderMonth))));
}

;// CONCATENATED MODULE: ./src/components/Root/index.ts


;// CONCATENATED MODULE: ./src/components/Row/Row.tsx




/**
 * Render a row in the calendar, with the days and optionally the week number.
 */
function Row(props) {
    var _a = useDayPicker(), styles = _a.styles, classNames = _a.classNames, showWeekNumber = _a.showWeekNumber, _b = _a.components, Day = _b.Day, WeekNumber = _b.WeekNumber;
    var weekNumberCell;
    if (showWeekNumber) {
        weekNumberCell = (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("th", { className: classNames[UIElement.RowHead], style: styles[UIElement.RowHead] },
            external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement(WeekNumber, { number: props.weekNumber, dates: props.dates })));
    }
    return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("tr", { className: classNames[UIElement.Row], style: styles[UIElement.Row] },
        weekNumberCell,
        props.dates.map(function (date) { return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("td", { className: classNames[UIElement.Cell], style: styles[UIElement.Cell], key: (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.getUnixTime)(date) },
            external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement(Day, { displayMonth: props.displayMonth, date: date }))); })));
}

;// CONCATENATED MODULE: ./src/components/Row/index.ts


;// CONCATENATED MODULE: ./src/components/Table/utils/getOutsideEndDays.ts

function getOutsideEndDays(month, options) {
    var days = [];
    var lastDayOfWeek = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.endOfWeek)(month, options);
    var endDiff = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.differenceInCalendarDays)(lastDayOfWeek, month);
    for (var i = 1; i <= endDiff; i++) {
        var dayDate = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.addDays)(month, i);
        days.push(dayDate);
    }
    return days;
}

;// CONCATENATED MODULE: ./src/components/Table/utils/getOutsideStartDays.ts

function getOutsideStartDays(month, options) {
    var days = [];
    var firstDayOfWeek = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.startOfWeek)(month, options);
    var startDiff = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.differenceInCalendarDays)(month, firstDayOfWeek);
    for (var i = 0; i < startDiff; i++) {
        var newDay = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.addDays)(firstDayOfWeek, i);
        days.push(newDay);
    }
    return days;
}

;// CONCATENATED MODULE: ./src/components/Table/utils/getWeeks.ts



/**
 * Return the weeks belonging to the given month.
 */
function getWeeks(month, _a) {
    var locale = _a.locale, fixedWeeks = _a.fixedWeeks;
    var monthStart = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.startOfMonth)(month);
    var monthEnd = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.endOfMonth)(month);
    var diff = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.differenceInCalendarDays)(monthEnd, monthStart);
    var weeks = {};
    var lastWeekStr = '';
    for (var i = 0; i <= diff; i++) {
        var date = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.addDays)(monthStart, i);
        var week = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.getWeek)(date, { locale: locale });
        if (week === 1 && (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.getMonth)(date) === 11) {
            week = 53;
        }
        var weekStr = week.toString();
        if (!weeks[weekStr]) {
            var startDays = getOutsideStartDays(date, { locale: locale });
            // Create a new week by adding outside start days
            weeks[weekStr] = startDays;
        }
        weeks[weekStr].push(date);
        lastWeekStr = weekStr;
    }
    var lastWeek = weeks[lastWeekStr];
    var lastDay = lastWeek[lastWeek.length - 1];
    var endDays = getOutsideEndDays(lastDay, { locale: locale });
    weeks[lastWeekStr] = lastWeek.concat(endDays);
    // Add extra weeks to the month, up to 6 weeks
    if (fixedWeeks) {
        lastWeek = weeks[lastWeekStr];
        var lastWeekDate = lastWeek[lastWeek.length - 1];
        var weeksInMonth = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.getWeeksInMonth)(month, { locale: locale });
        if (weeksInMonth < 6) {
            var diffDays = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.differenceInCalendarDays)((0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.addWeeks)(lastWeekDate, 6 - weeksInMonth), lastWeekDate);
            for (var i = 0; i < diffDays; i++) {
                var date = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.addDays)(lastWeekDate, i + 1);
                var week = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.getWeek)(date, { locale: locale });
                if (week === 1 && (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.getMonth)(month) === 11) {
                    week = 53;
                }
                if (!weeks[week]) {
                    weeks[week] = [];
                }
                weeks[week.toString()].push(date);
            }
        }
    }
    return weeks;
}

;// CONCATENATED MODULE: ./src/components/Table/Table.tsx





/**
 * Render the table with the calendar.
 */
function Table(props) {
    var _a = useDayPicker(), locale = _a.locale, classNames = _a.classNames, styles = _a.styles, hideHead = _a.hideHead, fixedWeeks = _a.fixedWeeks, Row = _a.components.Row;
    var weeks = getWeeks(props.displayMonth, { locale: locale, fixedWeeks: fixedWeeks });
    return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("table", { className: classNames[UIElement.Table], style: styles[UIElement.Table] },
        !hideHead && external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement(Head, null),
        external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("tbody", { className: classNames[UIElement.TBody], style: styles[UIElement.TBody] }, Object.keys(weeks).map(function (weekNumber) { return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement(Row, { displayMonth: props.displayMonth, key: weekNumber, dates: weeks[weekNumber], weekNumber: Number(weekNumber) })); }))));
}

;// CONCATENATED MODULE: ./src/components/Table/index.ts


;// CONCATENATED MODULE: ./src/components/WeekNumber/WeekNumber.tsx



/**
 * Render the week number element. If `onWeekNumberClick` is passed to DayPicker, it
 * renders a button, otherwise a span element.
 */
function WeekNumber(props) {
    var weekNumber = props.number, dates = props.dates;
    var _a = useDayPicker(), onWeekNumberClick = _a.onWeekNumberClick, styles = _a.styles, classNames = _a.classNames, locale = _a.locale, labelWeekNumber = _a.labels.labelWeekNumber, formatWeekNumber = _a.formatters.formatWeekNumber;
    var label = labelWeekNumber(Number(weekNumber), { locale: locale });
    var handleClick = function (e) {
        onWeekNumberClick === null || onWeekNumberClick === void 0 ? void 0 : onWeekNumberClick(weekNumber, dates, e);
    };
    var Component = onWeekNumberClick ? 'button' : 'span';
    return (external_root_React_commonjs2_react_commonjs_react_amd_react_default().createElement(Component, { "aria-label": label, className: classNames[UIElement.WeekNumber], style: styles[UIElement.WeekNumber], onClick: handleClick }, formatWeekNumber(Number(weekNumber), { locale: locale })));
}

;// CONCATENATED MODULE: ./src/components/WeekNumber/index.ts


;// CONCATENATED MODULE: ./src/components/YearsDropdown/YearsDropdown.tsx




/**
 * Render a dropdown to change the year. Take in account the `nav.fromDate` and
 * `toDate` from context.
 */
function YearsDropdown(props) {
    var displayMonth = props.displayMonth;
    var _a = useDayPicker(), fromDate = _a.fromDate, toDate = _a.toDate, locale = _a.locale, styles = _a.styles, classNames = _a.classNames, Dropdown = _a.components.Dropdown, formatYearCaption = _a.formatters.formatYearCaption;
    var years = [];
    if (fromDate && toDate) {
        var fromYear = fromDate.getFullYear();
        var toYear = toDate.getFullYear();
        for (var year = fromYear; year <= toYear; year++) {
            years.push((0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.setYear)((0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.startOfYear)(new Date()), year));
        }
    }
    var handleChange = function (e) {
        var newMonth = (0,external_root_DateFns_commonjs2_date_fns_commonjs_date_fns_amd_date_fns_.setYear)(new Date(displayMonth), Number(e.target.value));
        props.onChange(newMonth);
    };
    return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement(Dropdown, { className: classNames[UIElement.DropdownMonth], style: styles[UIElement.DropdownMonth], onChange: handleChange, value: displayMonth.getFullYear(), caption: formatYearCaption(displayMonth, { locale: locale }) }, years.map(function (year) { return (external_root_React_commonjs2_react_commonjs_react_amd_react_.createElement("option", { key: year.getFullYear(), value: year.getFullYear() }, formatYearCaption(year, { locale: locale }))); })));
}

;// CONCATENATED MODULE: ./src/components/YearsDropdown/index.ts


;// CONCATENATED MODULE: ./src/components/index.ts















;// CONCATENATED MODULE: ./src/index.ts




})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});
//# sourceMappingURL=index.js.map