/// <reference types="react" />
/** Represent the props of the [[Caption]] component. */
export interface CaptionProps {
    /** The month where the caption is displayed. */
    displayMonth: Date;
    /** The index of the month being displayed (when `numberOfMonths` set). */
    displayIndex: number;
    /** Whether the caption belongs to the first table (when `numberOfMonths` set). */
    isFirst: boolean;
    /** Whether the caption belongs to the last table (when `numberOfMonths` set). */
    isLast: boolean;
    /** Whether the caption belongs to a table between others (when `numberOfMonths` set).. */
    isBetween: boolean;
}
/**
 * Render the caption of a month, which includes title and navigation buttons.
 * The caption has a different layout when setting the `numberOfMonths` prop.
 */
export declare function Caption(props: CaptionProps): JSX.Element;
