/// <reference types="react" />
/** Represent the props used by the [[Day]] component. */
export interface DayProps {
    /** The month where the date is displayed. */
    displayMonth: Date;
    /** The date to render. */
    date: Date;
}
/**
 * Render the content of a date cell, as a button or span element according to
 * its modifiers. Attaches the event handlers from DayPicker context, and manage the
 * focused date.
 */
export declare function Day(props: DayProps): JSX.Element | null;
