import * as React from 'react';
import { useDayPicker } from '../../hooks';
import { UIElement } from '../../types';
import { IconDropdown } from '../IconDropdown';
/**
 * Render a dropdown component (basically, a styled HTMLSelectElement).
 */
export function Dropdown(props) {
    var onChange = props.onChange, value = props.value, children = props.children, caption = props.caption, className = props.className, style = props.style;
    var _a = useDayPicker(), classNames = _a.classNames, styles = _a.styles;
    return (React.createElement("div", { className: className, style: style },
        React.createElement("select", { className: classNames[UIElement.Dropdown], style: styles[UIElement.Dropdown], value: value, onChange: onChange }, children),
        React.createElement("div", { className: classNames[UIElement.CaptionLabel], style: styles[UIElement.CaptionLabel], "aria-hidden": "true" },
            caption,
            React.createElement(IconDropdown, { className: classNames[UIElement.DropdownIcon], style: styles[UIElement.DropdownIcon] }))));
}
//# sourceMappingURL=Dropdown.js.map