import React from 'react';
import { useDayPicker } from '../../hooks';
import { UIElement } from '../../types';
/**
 * Render the Head component - i.e. the table head with the weekday names.
 */
export function Head() {
    var _a = useDayPicker(), classNames = _a.classNames, styles = _a.styles, showWeekNumber = _a.showWeekNumber, locale = _a.locale, formatWeekdayName = _a.formatters.formatWeekdayName, labelWeekday = _a.labels.labelWeekday, weekdays = _a.weekdays;
    return (React.createElement("thead", { style: styles[UIElement.Head], className: classNames[UIElement.Head] },
        React.createElement("tr", { style: styles[UIElement.HeadRow], className: classNames[UIElement.HeadRow] },
            showWeekNumber && (React.createElement("th", { style: styles[UIElement.HeadCell], className: classNames[UIElement.HeadCell] })),
            weekdays.map(function (weekday, i) { return (React.createElement("th", { key: i, scope: "col", className: classNames[UIElement.HeadCell], style: styles[UIElement.HeadCell], "aria-label": labelWeekday(weekday, { locale: locale }) }, formatWeekdayName(weekday, { locale: locale }))); }))));
}
//# sourceMappingURL=Head.js.map