import * as React from 'react';
import { Head } from '../../components';
import { useDayPicker } from '../../hooks';
import { UIElement } from '../../types';
import { getWeeks } from './utils/getWeeks';
/**
 * Render the table with the calendar.
 */
export function Table(props) {
    var _a = useDayPicker(), locale = _a.locale, classNames = _a.classNames, styles = _a.styles, hideHead = _a.hideHead, fixedWeeks = _a.fixedWeeks, Row = _a.components.Row;
    var weeks = getWeeks(props.displayMonth, { locale: locale, fixedWeeks: fixedWeeks });
    return (React.createElement("table", { className: classNames[UIElement.Table], style: styles[UIElement.Table] },
        !hideHead && React.createElement(Head, null),
        React.createElement("tbody", { className: classNames[UIElement.TBody], style: styles[UIElement.TBody] }, Object.keys(weeks).map(function (weekNumber) { return (React.createElement(Row, { displayMonth: props.displayMonth, key: weekNumber, dates: weeks[weekNumber], weekNumber: Number(weekNumber) })); }))));
}
//# sourceMappingURL=Table.js.map