import { startOfMonth } from 'date-fns';
/**
 * Build the `fromDate` and `toDate` context values, given the fromMonth/toMonth
 * or fromYear/toYear.
 */
export function parseFromToProps(props) {
    // Merge the from*/to* props into fromDate/toDate
    var fromDate = props.fromDate;
    if (props.fromMonth) {
        fromDate = startOfMonth(props.fromMonth);
    }
    else if (props.fromYear) {
        fromDate = new Date(props.fromYear, 0, 1);
    }
    var toDate = props.toDate;
    if (props.toMonth) {
        toDate = startOfMonth(props.toMonth);
    }
    else if (props.toYear) {
        toDate = new Date(props.toYear, 11, 31);
    }
    return { fromDate: fromDate, toDate: toDate };
}
//# sourceMappingURL=parseFromToProps.js.map