import * as React from 'react';
export declare type FocusContextValue = [
    focusedDay: Date | undefined,
    setters: {
        focus: (day: Date) => void;
        blur: () => void;
        focusDayAfter: () => void;
        focusDayBefore: () => void;
        focusDayUp: () => void;
        focusDayDown: () => void;
    }
];
/**
 * The focus context holds values and method to handle the focused day via
 * keyboard navigation.
 */
export declare const FocusContext: React.Context<FocusContextValue | undefined>;
/** Enable the FocusContext to handle the focus when navigating via keyboard. */
export declare const FocusProvider: ({ children }: {
    children: React.ReactNode;
}) => JSX.Element;
