import { isMatch } from './isMatch';
/**
 * Return the status of the modifiers for the given day,
 */
export function getModifierStatus(day, 
/** The modifiers for the given day. */
modifiers) {
    var modifiersList = Object.keys(modifiers).reduce(function (previousValue, key) {
        var modifier = modifiers[key];
        if (isMatch(day, modifier)) {
            previousValue.push(key);
        }
        return previousValue;
    }, []);
    var modifiersStatus = {};
    modifiersList.forEach(function (modifier) { return (modifiersStatus[modifier] = true); });
    return modifiersStatus;
}
//# sourceMappingURL=getModifierStatus.js.map