import { differenceInCalendarDays, isSameDay } from 'date-fns';
export function matchRange(day, matcher) {
    var _a;
    if (!('from' in matcher))
        return false;
    if (!matcher.from)
        return false;
    var from = matcher.from, to = matcher.to;
    // Matches { from: <Date> }
    if (!to && from && isSameDay(from, day))
        return true;
    if (!to)
        return false;
    // Invert the case where "to" is before "from"
    if (matcher.to && differenceInCalendarDays(matcher.to, matcher.from) < 0) {
        _a = [matcher.to, matcher.from], from = _a[0], to = _a[1];
    }
    return (differenceInCalendarDays(day, from) >= 0 &&
        differenceInCalendarDays(to, day) >= 0);
}
//# sourceMappingURL=matchRange.js.map