import * as React from 'react';
export declare type NavigationContextValue = {
    /** The current month. Note that when `numberOfMonths > 1` represent the first month in the displayed months. */
    month: Date;
    /** The months to display, according to `numberOfMonths`. */
    displayMonths: Date[];
    /** Navigate to the specified month. */
    setMonth: (month: Date) => void;
};
/** The navigation context holds values and setters for navigating between the
 * calendars. */
export declare const NavigationContext: React.Context<NavigationContextValue | undefined>;
/** Provides the values for the [[NavigationContext]]. */
export declare const NavigationProvider: ({ children }: {
    children?: React.ReactNode;
}) => JSX.Element;
