import * as React from 'react';
import { isSameMonth } from 'date-fns';
import { useDayPicker } from '../useDayPicker';
import { getDisplayMonths } from './utils/getDisplayMonths';
/** The navigation context holds values and setters for navigating between the
 * calendars. */
export var NavigationContext = React.createContext(undefined);
/** Provides the values for the [[NavigationContext]]. */
export var NavigationProvider = function (_a) {
    var children = _a.children;
    var context = useDayPicker();
    var _b = React.useState(context.month || context.defaultMonth || context.today), month = _b[0], setMonthInternal = _b[1];
    var setMonth = function (date) {
        if (context.disableNavigation)
            return;
        setMonthInternal(date);
    };
    React.useEffect(function () {
        if (!context.month)
            return;
        if (isSameMonth(context.month, month))
            return;
        setMonth(context.month);
    }, [context.month]);
    var displayMonths = getDisplayMonths(month, context);
    return (React.createElement(NavigationContext.Provider, { value: { month: month, displayMonths: displayMonths, setMonth: setMonth } }, children));
};
//# sourceMappingURL=NavigationContext.js.map