import { addMonths, differenceInMonths, startOfMonth } from 'date-fns';
/**
 * Return the months to display in the component according to the number of
 * months and the from/to date.
 */
export function getDisplayMonths(month, _a) {
    var toDate = _a.toDate, fromDate = _a.fromDate, reverseMonths = _a.reverseMonths, numberOfMonths = _a.numberOfMonths;
    var start = startOfMonth(month);
    var end = startOfMonth(addMonths(start, numberOfMonths));
    var monthsDiff = differenceInMonths(end, start);
    var months = [];
    for (var i = 0; i < monthsDiff; i++) {
        var nextMonth = addMonths(start, i);
        if (toDate && nextMonth > startOfMonth(toDate))
            continue;
        if (fromDate && nextMonth < startOfMonth(fromDate))
            continue;
        months.push(nextMonth);
    }
    if (reverseMonths)
        months = months.reverse();
    return months;
}
//# sourceMappingURL=getDisplayMonths.js.map