import * as React from 'react';
import { useDayPicker } from '../useDayPicker';
import { useMultipleSelect } from './useSelectMultiple';
import { useRangeSelect } from './useSelectRange';
import { useSingleSelect } from './useSingleSelect';
export var SelectionContext = React.createContext(undefined);
/**
 * Provides the setters and values for the controlled selection modes.
 */
export var SelectionProvider = function (props) {
    var dayPickerProps = useDayPicker();
    var single = useSingleSelect('single', dayPickerProps.defaultSelected, dayPickerProps.required, dayPickerProps.onSelect);
    var multiple = useMultipleSelect('multiple', dayPickerProps.defaultSelected, dayPickerProps.required, dayPickerProps.onSelectMultiple);
    var range = useRangeSelect('range', dayPickerProps.defaultSelected, dayPickerProps.required, dayPickerProps.onSelectRange);
    return (React.createElement(SelectionContext.Provider, { value: { single: single, multiple: multiple, range: range } }, props.children));
};
//# sourceMappingURL=SelectionContext.js.map