var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import { useState } from 'react';
import { isSameDay } from 'date-fns';
/** Hook to handle multiple selections. */
export function useMultipleSelect(mode, defaultValue, required, callback) {
    if (required === void 0) { required = false; }
    var initialValue = mode === 'multiple' && defaultValue ? defaultValue : [];
    var _a = useState(initialValue), selected = _a[0], setSelected = _a[1];
    var handleClick = function (day, modifiers, e) {
        setSelected(function (currentValue) {
            var newValue = __spreadArrays(currentValue);
            if (modifiers.selected) {
                if (required && currentValue.length === 1) {
                    return newValue;
                }
                var index = currentValue.findIndex(function (value) { return isSameDay(day, value); });
                newValue.splice(index, 1);
            }
            else {
                newValue.push(day);
            }
            callback === null || callback === void 0 ? void 0 : callback(newValue, day, modifiers, e);
            return newValue;
        });
    };
    var reset = function () {
        setSelected(initialValue);
    };
    return { selected: selected, onDayClick: handleClick, reset: reset };
}
//# sourceMappingURL=useSelectMultiple.js.map