import { useState } from 'react';
import { addToRange } from './utils/addToRange';
/** Hook to handle range selections. */
export function useRangeSelect(mode, defaultValue, required, callback) {
    if (required === void 0) { required = false; }
    var initialValue = mode === 'range' && defaultValue ? defaultValue : undefined;
    var _a = useState(initialValue), selected = _a[0], setSelected = _a[1];
    var onDayClick = function (day, modifiers, e) {
        setSelected(function (currentValue) {
            var newValue = addToRange(day, currentValue, required);
            callback === null || callback === void 0 ? void 0 : callback(newValue, day, modifiers, e);
            setSelected(newValue);
            return newValue;
        });
        return;
    };
    var reset = function () {
        setSelected(initialValue || undefined);
    };
    return { selected: selected, onDayClick: onDayClick, reset: reset };
}
//# sourceMappingURL=useSelectRange.js.map