import React from 'react';
import { SelectionContext } from './SelectionContext';
/** Return the context for the controlled mode selection. */
export function useSelection() {
    var context = React.useContext(SelectionContext);
    if (!context) {
        throw new Error('useSelection must be used within a SelectionProvider');
    }
    return context;
}
//# sourceMappingURL=useSelection.js.map