import { useState } from 'react';
/** Hook to handle single selections. */
export function useSingleSelect(mode, defaultValue, required, callback) {
    if (required === void 0) { required = false; }
    var initialValue = mode === 'single' && defaultValue ? defaultValue : undefined;
    var _a = useState(initialValue), selected = _a[0], setSelected = _a[1];
    var onDayClick = function (day, modifiers, e) {
        if (modifiers.selected) {
            if (!required) {
                setSelected(undefined);
                callback === null || callback === void 0 ? void 0 : callback(undefined, day, modifiers, e);
            }
            return;
        }
        setSelected(day);
        callback === null || callback === void 0 ? void 0 : callback(day, day, modifiers, e);
    };
    var reset = function () {
        setSelected(initialValue);
    };
    return { selected: selected, onDayClick: onDayClick, reset: reset };
}
//# sourceMappingURL=useSingleSelect.js.map